###########################################
################ Functions ################
###########################################




sub date {
    my $time = shift || time;           #$time par defaut vaut le time actuel
    my @tab_date =localtime($time); 
    $tab_date[4] = $tab_date[4] + 1;    #modification mois
    #L'annee renvoie est celle à partir de 1900
     #d'ou la modification
     $tab_date[5] = $tab_date[5] + 1900;
    
    # On rajoute 0 si le chiffre est compris entre 1 et 9
    foreach  (@tab_date) {
      s/^(\d)$/0$1/;
    }

    my ($seconde, $minute, $heure,
        $jour   , $mois  , $annee,
        $jour_semaine   ,  $jour_annee , $heure_hiver_ou_ete
        ) = @tab_date;
    my %date = (
      "date"  => "$annee-$mois-$jour",
      "heure" => "$heure:$minute:$seconde",
      "jour_semaine" => $jour_semaine,
      "jour_annee"   => $jour_annee,
      "hiverOuEte"   => $heure_hiver_ou_ete,
    );    
    return \%date;
}



sub date_now {
   $actualdate = date($time);
   return $actualdate->{date}." ".$actualdate->{heure};
}

sub hashValueDescendingNum {
   $b <=> $a;
}

sub debug {
   my $log = shift;
   my $text = shift;
   my $dump = shift;
   my $PID = shift;
   my $Bin = shift;

   if ($log eq "2"){
      open (DEBUG, '>>'.$Bin.'/log/'.$PID.'.log') || die ("Erreur d'ouverture du fichier de LOG") ;;
      if ($dump eq "dump") {
         print DEBUG Dumper($text);
      } else {
         print DEBUG $text."\n";
      }
      close (DEBUG);
   }
}

sub special_char {
   if (defined($_[0]))
   {
      if ($_[0] =~ m/\^\>/){
         return "";
      }elsif ($_[0] =~ m/\^\</){
         return "";
      }elsif ($_[0] =~ m/\x1D/){
         return "";
      }elsif($_[0] =~ m/\x0C/){
         return "";
      }elsif($_[0] =~ m/\!\^ /){
         return "";
      }elsif($_[0] =~ m/\]F:0\{/){
         return "";
      }elsif($_[0] =~ m/Q\,\_/){
         return "";
      }else{
         $_[0] =~ s/^\x00//;
      }
      return $_[0];
   }
   else
   {
      return "";
   }

}
1;